Index: palm/trunk/SOURCE/data_output_netcdf4_module.f90
===================================================================
--- palm/trunk/SOURCE/data_output_netcdf4_module.f90	(revision 4146)
+++ palm/trunk/SOURCE/data_output_netcdf4_module.f90	(revision 4147)
@@ -383,67 +386,68 @@
 !> Initialize variable.
 !--------------------------------------------------------------------------------------------------!
-SUBROUTINE netcdf4_init_variable( mode, file_id, variable_id, variable_name, variable_type, &
-                                  dimension_ids, is_global, return_value )
-
-   CHARACTER(LEN=*), INTENT(IN) ::  mode           !< operation mode (either parallel or serial)
-   CHARACTER(LEN=*), INTENT(IN) ::  variable_name  !< name of variable
-   CHARACTER(LEN=*), INTENT(IN) ::  variable_type  !< data type of variable
-
-   CHARACTER(LEN=*), PARAMETER ::  routine_name = 'netcdf4_init_variable'  !< name of this routine
-
-   INTEGER, INTENT(IN)  ::  file_id           !< file ID
-   INTEGER              ::  nc_stat           !< netcdf return value
-   INTEGER              ::  nc_variable_type  !< netcdf data type
-   INTEGER, INTENT(OUT) ::  return_value      !< return value
-   INTEGER, INTENT(OUT) ::  variable_id       !< variable ID
-
-   INTEGER, DIMENSION(:), INTENT(IN) ::  dimension_ids  !< list of dimension IDs used by variable
-
-   LOGICAL, INTENT(IN)  ::  is_global  !< true if variable is global (same on all PE)
-
-
-#if defined( __netcdf4 )
-   return_value = 0
-
-   WRITE( temp_string, * ) is_global
-   CALL internal_message( 'debug', routine_name //                        &
-                          ': init variable "' // TRIM( variable_name ) // &
-                          '" ( is_global = ' // TRIM( temp_string ) // ')' )
-
-   nc_variable_type = get_netcdf_data_type( variable_type )
-
-   IF ( nc_variable_type /= -1 )  THEN
-
-      !-- Define variable in file
-      nc_stat = NF90_DEF_VAR( file_id, variable_name, nc_variable_type, dimension_ids, variable_id )
+ SUBROUTINE netcdf4_init_variable( mode, file_id, variable_id, variable_name, variable_type, &
+                                   dimension_ids, is_global, return_value )
+
+    CHARACTER(LEN=*), INTENT(IN) ::  mode           !< operation mode (either parallel or serial)
+    CHARACTER(LEN=*), INTENT(IN) ::  variable_name  !< name of variable
+    CHARACTER(LEN=*), INTENT(IN) ::  variable_type  !< data type of variable
+
+    CHARACTER(LEN=*), PARAMETER ::  routine_name = 'netcdf4_init_variable'  !< name of this routine
+
+    INTEGER, INTENT(IN)  ::  file_id           !< file ID
+    INTEGER              ::  nc_stat           !< netcdf return value
+    INTEGER              ::  nc_variable_type  !< netcdf data type
+    INTEGER, INTENT(OUT) ::  return_value      !< return value
+    INTEGER, INTENT(OUT) ::  variable_id       !< variable ID
+
+    INTEGER, DIMENSION(:), INTENT(IN) ::  dimension_ids  !< list of dimension IDs used by variable
+
+    LOGICAL, INTENT(IN)  ::  is_global  !< true if variable is global (same on all PE)
+
+
+#if defined( __netcdf4 )
+    return_value = 0
+
+    WRITE( temp_string, * ) is_global
+    CALL internal_message( 'debug', routine_name //                        &
+                           ': init variable "' // TRIM( variable_name ) // &
+                           '" ( is_global = ' // TRIM( temp_string ) // ')' )
+
+    nc_variable_type = get_netcdf_data_type( variable_type )
+
+    IF ( nc_variable_type /= -1 )  THEN
+!
+!--    Define variable in file
+       nc_stat = NF90_DEF_VAR( file_id, variable_name, nc_variable_type, dimension_ids, variable_id )
 
 #if defined( __netcdf4_parallel )
-      !-- Define how variable can be accessed by PEs in parallel netcdf file
-      IF ( nc_stat == NF90_NOERR  .AND.  TRIM( mode ) == mode_parallel )  THEN
-         IF ( is_global )  THEN
-            nc_stat = NF90_VAR_PAR_ACCESS( file_id, variable_id, NF90_INDEPENDENT )
-         ELSE
-            nc_stat = NF90_VAR_PAR_ACCESS( file_id, variable_id, NF90_COLLECTIVE )
-         ENDIF
-      ENDIF
-#endif
-
-      IF ( nc_stat /= NF90_NOERR )  THEN
-         return_value = 1
-         CALL internal_message( 'error', routine_name //                          &
-                                ': NetCDF error while initializing variable "' // &
-                                TRIM( variable_name ) // '": ' // NF90_STRERROR( nc_stat ) )
-      ENDIF
-
-   ELSE
-      return_value = 1
-   ENDIF
-
-#else
-   return_value = 1
-   variable_id = -1
-#endif
-
-END SUBROUTINE netcdf4_init_variable
+!
+!--    Define how variable can be accessed by PEs in parallel netcdf file
+       IF ( nc_stat == NF90_NOERR  .AND.  TRIM( mode ) == mode_parallel )  THEN
+          IF ( is_global )  THEN
+             nc_stat = NF90_VAR_PAR_ACCESS( file_id, variable_id, NF90_INDEPENDENT )
+          ELSE
+             nc_stat = NF90_VAR_PAR_ACCESS( file_id, variable_id, NF90_COLLECTIVE )
+          ENDIF
+       ENDIF
+#endif
+
+       IF ( nc_stat /= NF90_NOERR )  THEN
+          return_value = 1
+          CALL internal_message( 'error', routine_name //                          &
+                                 ': NetCDF error while initializing variable "' // &
+                                 TRIM( variable_name ) // '": ' // NF90_STRERROR( nc_stat ) )
+       ENDIF
+
+    ELSE
+       return_value = 1
+    ENDIF
+
+#else
+    return_value = 1
+    variable_id = -1
+#endif
+
+ END SUBROUTINE netcdf4_init_variable
 
 !--------------------------------------------------------------------------------------------------!
@@ -452,38 +456,38 @@
 !> Leave file definition state.
 !--------------------------------------------------------------------------------------------------!
-SUBROUTINE netcdf4_stop_file_header_definition( file_id, return_value )
-
-   CHARACTER(LEN=*), PARAMETER ::  routine_name = 'netcdf4_stop_file_header_definition'  !< name of this routine
-
-   INTEGER, INTENT(IN)  ::  file_id        !< file ID
-   INTEGER              ::  nc_stat        !< netcdf return value
-   INTEGER              ::  old_fill_mode  !< previous netcdf fill mode
-   INTEGER, INTENT(OUT) ::  return_value   !< return value
-
-
-#if defined( __netcdf4 )
-   return_value = 0
-
-   WRITE( temp_string, * ) file_id
-   CALL internal_message( 'debug', routine_name // &
-                          ': finalize file definition (file_id=' // TRIM( temp_string ) // ')' )
-
-   !-- Set general no fill, otherwise the performance drops significantly
-   nc_stat = NF90_SET_FILL( file_id, NF90_NOFILL, old_fill_mode )
-
-   IF ( nc_stat == NF90_NOERR )  THEN
-      nc_stat = NF90_ENDDEF( file_id )
-   ENDIF
-
-   IF ( nc_stat /= NF90_NOERR )  THEN
-      return_value = 1
-      CALL internal_message( 'error', routine_name // &
-                             ': NetCDF error: ' // NF90_STRERROR( nc_stat ) )
-   ENDIF
-#else
-   return_value = 1
-#endif
-
-END SUBROUTINE netcdf4_stop_file_header_definition
+ SUBROUTINE netcdf4_stop_file_header_definition( file_id, return_value )
+
+    CHARACTER(LEN=*), PARAMETER ::  routine_name = 'netcdf4_stop_file_header_definition'  !< name of this routine
+
+    INTEGER, INTENT(IN)  ::  file_id        !< file ID
+    INTEGER              ::  nc_stat        !< netcdf return value
+    INTEGER              ::  old_fill_mode  !< previous netcdf fill mode
+    INTEGER, INTENT(OUT) ::  return_value   !< return value
+
+
+#if defined( __netcdf4 )
+    return_value = 0
+
+    WRITE( temp_string, * ) file_id
+    CALL internal_message( 'debug', routine_name // &
+                           ': finalize file definition (file_id=' // TRIM( temp_string ) // ')' )
+!
+!-- Set general no fill, otherwise the performance drops significantly
+    nc_stat = NF90_SET_FILL( file_id, NF90_NOFILL, old_fill_mode )
+
+    IF ( nc_stat == NF90_NOERR )  THEN
+       nc_stat = NF90_ENDDEF( file_id )
+    ENDIF
+
+    IF ( nc_stat /= NF90_NOERR )  THEN
+       return_value = 1
+       CALL internal_message( 'error', routine_name // &
+                              ': NetCDF error: ' // NF90_STRERROR( nc_stat ) )
+    ENDIF
+#else
+    return_value = 1
+#endif
+
+ END SUBROUTINE netcdf4_stop_file_header_definition
 
 !--------------------------------------------------------------------------------------------------!
@@ -492,63 +496,63 @@
 !> Write variable of different kind into netcdf file.
 !--------------------------------------------------------------------------------------------------!
-SUBROUTINE netcdf4_write_variable(                                                    &
-              file_id, variable_id, bounds_start, value_counts, bounds_origin,        &
-              is_global,                                                              &
-              values_int8_0d,   values_int8_1d,   values_int8_2d,   values_int8_3d,   &
-              values_int16_0d,  values_int16_1d,  values_int16_2d,  values_int16_3d,  &
-              values_int32_0d,  values_int32_1d,  values_int32_2d,  values_int32_3d,  &
-              values_intwp_0d,  values_intwp_1d,  values_intwp_2d,  values_intwp_3d,  &
-              values_real32_0d, values_real32_1d, values_real32_2d, values_real32_3d, &
-              values_real64_0d, values_real64_1d, values_real64_2d, values_real64_3d, &
-              values_realwp_0d, values_realwp_1d, values_realwp_2d, values_realwp_3d, &
-              return_value )
-
-   CHARACTER(LEN=*), PARAMETER ::  routine_name = 'netcdf4_write_variable'  !< name of this routine
-
-   INTEGER              ::  d             !< loop index
-   INTEGER, INTENT(IN)  ::  file_id       !< file ID
-   INTEGER              ::  my_rank       !< MPI rank of processor
-   INTEGER              ::  nc_stat       !< netcdf return value
-   INTEGER              ::  ndims         !< number of dimensions of variable in file
-   INTEGER, INTENT(OUT) ::  return_value  !< return value
-   INTEGER, INTENT(IN)  ::  variable_id   !< variable ID
-
-   INTEGER, DIMENSION(:),              INTENT(IN)  ::  bounds_origin      !< starting index of each dimension
-   INTEGER, DIMENSION(:),              INTENT(IN)  ::  bounds_start       !< starting index of variable
-   INTEGER, DIMENSION(:), ALLOCATABLE              ::  dimension_ids      !< IDs of dimensions of variable in file
-   INTEGER, DIMENSION(:), ALLOCATABLE              ::  dimension_lengths  !< length of dimensions of variable in file
-   INTEGER, DIMENSION(:),              INTENT(IN)  ::  value_counts       !< count of values along each dimension to be written
-
-   INTEGER(KIND=1), POINTER,             INTENT(IN), OPTIONAL                   ::  values_int8_0d   !< output variable
-   INTEGER(KIND=2), POINTER,             INTENT(IN), OPTIONAL                   ::  values_int16_0d  !< output variable
-   INTEGER(KIND=4), POINTER,             INTENT(IN), OPTIONAL                   ::  values_int32_0d  !< output variable
-   INTEGER(iwp),    POINTER,             INTENT(IN), OPTIONAL                   ::  values_intwp_0d  !< output variable
-   INTEGER(KIND=1), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:)     ::  values_int8_1d   !< output variable
-   INTEGER(KIND=2), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:)     ::  values_int16_1d  !< output variable
-   INTEGER(KIND=4), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:)     ::  values_int32_1d  !< output variable
-   INTEGER(iwp),    POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:)     ::  values_intwp_1d  !< output variable
-   INTEGER(KIND=1), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:,:)   ::  values_int8_2d   !< output variable
-   INTEGER(KIND=2), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:,:)   ::  values_int16_2d  !< output variable
-   INTEGER(KIND=4), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:,:)   ::  values_int32_2d  !< output variable
-   INTEGER(iwp),    POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:,:)   ::  values_intwp_2d  !< output variable
-   INTEGER(KIND=1), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:,:,:) ::  values_int8_3d   !< output variable
-   INTEGER(KIND=2), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:,:,:) ::  values_int16_3d  !< output variable
-   INTEGER(KIND=4), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:,:,:) ::  values_int32_3d  !< output variable
-   INTEGER(iwp),    POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:,:,:) ::  values_intwp_3d  !< output variable
-
-   LOGICAL, INTENT(IN) ::  is_global  !< true if variable is global (same on all PE)
-
-   REAL(KIND=4), POINTER,             INTENT(IN), OPTIONAL                   ::  values_real32_0d  !< output variable
-   REAL(KIND=8), POINTER,             INTENT(IN), OPTIONAL                   ::  values_real64_0d  !< output variable
-   REAL(wp),     POINTER,             INTENT(IN), OPTIONAL                   ::  values_realwp_0d  !< output variable
-   REAL(KIND=4), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:)     ::  values_real32_1d  !< output variable
-   REAL(KIND=8), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:)     ::  values_real64_1d  !< output variable
-   REAL(wp),     POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:)     ::  values_realwp_1d  !< output variable
-   REAL(KIND=4), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:,:)   ::  values_real32_2d  !< output variable
-   REAL(KIND=8), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:,:)   ::  values_real64_2d  !< output variable
-   REAL(wp),     POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:,:)   ::  values_realwp_2d  !< output variable
-   REAL(KIND=4), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:,:,:) ::  values_real32_3d  !< output variable
-   REAL(KIND=8), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:,:,:) ::  values_real64_3d  !< output variable
-   REAL(wp),     POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:,:,:) ::  values_realwp_3d  !< output variable
+ SUBROUTINE netcdf4_write_variable(                                                    &
+               file_id, variable_id, bounds_start, value_counts, bounds_origin,        &
+               is_global,                                                              &
+               values_int8_0d,   values_int8_1d,   values_int8_2d,   values_int8_3d,   &
+               values_int16_0d,  values_int16_1d,  values_int16_2d,  values_int16_3d,  &
+               values_int32_0d,  values_int32_1d,  values_int32_2d,  values_int32_3d,  &
+               values_intwp_0d,  values_intwp_1d,  values_intwp_2d,  values_intwp_3d,  &
+               values_real32_0d, values_real32_1d, values_real32_2d, values_real32_3d, &
+               values_real64_0d, values_real64_1d, values_real64_2d, values_real64_3d, &
+               values_realwp_0d, values_realwp_1d, values_realwp_2d, values_realwp_3d, &
+               return_value )
+
+    CHARACTER(LEN=*), PARAMETER ::  routine_name = 'netcdf4_write_variable'  !< name of this routine
+
+    INTEGER              ::  d             !< loop index
+    INTEGER, INTENT(IN)  ::  file_id       !< file ID
+    INTEGER              ::  my_rank       !< MPI rank of processor
+    INTEGER              ::  nc_stat       !< netcdf return value
+    INTEGER              ::  ndims         !< number of dimensions of variable in file
+    INTEGER, INTENT(OUT) ::  return_value  !< return value
+    INTEGER, INTENT(IN)  ::  variable_id   !< variable ID
+
+    INTEGER, DIMENSION(:),              INTENT(IN)  ::  bounds_origin      !< starting index of each dimension
+    INTEGER, DIMENSION(:),              INTENT(IN)  ::  bounds_start       !< starting index of variable
+    INTEGER, DIMENSION(:), ALLOCATABLE              ::  dimension_ids      !< IDs of dimensions of variable in file
+    INTEGER, DIMENSION(:), ALLOCATABLE              ::  dimension_lengths  !< length of dimensions of variable in file
+    INTEGER, DIMENSION(:),              INTENT(IN)  ::  value_counts       !< count of values along each dimension to be written
+
+    INTEGER(KIND=1), POINTER,             INTENT(IN), OPTIONAL                   ::  values_int8_0d   !< output variable
+    INTEGER(KIND=2), POINTER,             INTENT(IN), OPTIONAL                   ::  values_int16_0d  !< output variable
+    INTEGER(KIND=4), POINTER,             INTENT(IN), OPTIONAL                   ::  values_int32_0d  !< output variable
+    INTEGER(iwp),    POINTER,             INTENT(IN), OPTIONAL                   ::  values_intwp_0d  !< output variable
+    INTEGER(KIND=1), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:)     ::  values_int8_1d   !< output variable
+    INTEGER(KIND=2), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:)     ::  values_int16_1d  !< output variable
+    INTEGER(KIND=4), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:)     ::  values_int32_1d  !< output variable
+    INTEGER(iwp),    POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:)     ::  values_intwp_1d  !< output variable
+    INTEGER(KIND=1), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:,:)   ::  values_int8_2d   !< output variable
+    INTEGER(KIND=2), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:,:)   ::  values_int16_2d  !< output variable
+    INTEGER(KIND=4), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:,:)   ::  values_int32_2d  !< output variable
+    INTEGER(iwp),    POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:,:)   ::  values_intwp_2d  !< output variable
+    INTEGER(KIND=1), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:,:,:) ::  values_int8_3d   !< output variable
+    INTEGER(KIND=2), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:,:,:) ::  values_int16_3d  !< output variable
+    INTEGER(KIND=4), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:,:,:) ::  values_int32_3d  !< output variable
+    INTEGER(iwp),    POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:,:,:) ::  values_intwp_3d  !< output variable
+
+    LOGICAL, INTENT(IN) ::  is_global  !< true if variable is global (same on all PE)
+
+    REAL(KIND=4), POINTER,             INTENT(IN), OPTIONAL                   ::  values_real32_0d  !< output variable
+    REAL(KIND=8), POINTER,             INTENT(IN), OPTIONAL                   ::  values_real64_0d  !< output variable
+    REAL(wp),     POINTER,             INTENT(IN), OPTIONAL                   ::  values_realwp_0d  !< output variable
+    REAL(KIND=4), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:)     ::  values_real32_1d  !< output variable
+    REAL(KIND=8), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:)     ::  values_real64_1d  !< output variable
+    REAL(wp),     POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:)     ::  values_realwp_1d  !< output variable
+    REAL(KIND=4), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:,:)   ::  values_real32_2d  !< output variable
+    REAL(KIND=8), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:,:)   ::  values_real64_2d  !< output variable
+    REAL(wp),     POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:,:)   ::  values_realwp_2d  !< output variable
+    REAL(KIND=4), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:,:,:) ::  values_real32_3d  !< output variable
+    REAL(KIND=8), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:,:,:) ::  values_real64_3d  !< output variable
+    REAL(wp),     POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:,:,:) ::  values_realwp_3d  !< output variable
 
 
